; Special identifiers
;--------------------

([
    (identifier)
    (shorthand_property_identifier)
    (shorthand_property_identifier_pattern)
 ] @identifier.constant
 (#match? @identifier.constant "^[A-Z_][A-Z\\d_]+$"))


((identifier) @identifier.variable.builtin
 (#match? @identifier.variable.builtin "^(arguments|module|console|window|document)$"))

((identifier) @identifier.function.builtin
 (#eq? @identifier.function.builtin "require"))
 
; Properties
;-----------

(public_field_definition (property_identifier) @identifier.property)
(public_field_definition (private_property_identifier) @identifier.property)

; Properties
;-----------

((member_expression
 property: (property_identifier) @identifier.property) @_expr
 (#not-has-parent? @_expr "call_expression"))
((member_expression
 property: (private_property_identifier) @identifier.property) @_expr
 (#not-has-parent? @_expr "call_expression"))

; Function and method definitions
;--------------------------------

(function
  name: (identifier) @identifier.function)
(function_declaration
  name: (identifier) @identifier.function)
(method_definition
  name: (property_identifier) @identifier.method)

(pair
  key: (property_identifier) @identifier.method
  value: [(function) (arrow_function)])

(assignment_expression
  left: (member_expression
    property: (property_identifier) @identifier.method)
  right: [(function) (arrow_function)])

(variable_declarator
  name: (identifier) @identifier.method
  value: [(function) (arrow_function)])

(assignment_expression
  left: (identifier) @identifier.method
  right: [(function) (arrow_function)])

; Function and method calls
;--------------------------

(call_expression
  function: (identifier) @identifier.function)

(call_expression
  function: (member_expression
    property: (property_identifier) @identifier.method))

; Decorators
;-----------

(decorator
  "@" @identifier.decorator
  (identifier)? @identifier.decorator
  (call_expression function: (identifier) @identifier.decorator)?)

; Literals
;---------

(this) @keyword.self
(super) @keyword.self

[
  (true)
  (false)
  (null)
  (undefined)
] @keyword

(comment) @comment

[
  (string
    ["\"" "'"] @string.delimiter.left
    ["\"" "'"] @string.delimiter.right
  )
  (template_string
    "`" @string.delimiter.left
    
    ((template_substitution
      "${" @bracket @highlight.reset.start
      "}" @highlight.reset.end)
    )*
    
    "`" @string.delimiter.right
  )
] @string

(regex) @regex
(number) @value.number

; Tokens
;-------

[
  ";"
  "?."
  "."
  ","
] @punctuation.delimiter

(optional_chain) @punctuation.delimiter

(spread_element
  "..." @operator
)

(binary_expression
  operator: "/" @operator)

[
  "-"
  "--"
  "-="
  "+"
  "++"
  "+="
  "*"
  "*="
  "**"
  "**="
  ;"/" Handled separately for regex
  "/="
  "%"
  "%="
  ;"<" Handled separately for tsx
  "<="
  "<<"
  "<<="
  "="
  "=="
  "==="
  "!"
  "!="
  "!=="
  "=>"
  ;">" Handled separately for tsx
  ">="
  ">>"
  ">>="
  ">>>"
  ">>>="
  "~"
  "^"
  "&"
  "|"
  "^="
  "&="
  "|="
  "&&"
  "||"
  "??"
  "&&="
  "||="
  "??="
] @operator

(binary_expression operator: "<" @operator)
(binary_expression operator: ">" @operator)

(ternary_expression "?" @operator ":" @operator)

[
  "("
  ")"
  "["
  "]"
  "{"
  "}"
]  @bracket

[
  "await"
  "break"
  "case"
  "catch"
  "class"
  "const"
  "continue"
  "debugger"
  "default"
  "delete"
  "do"
  "else"
  "enum"
  "finally"
  "for"
  "function"
  "if"
  "import"
  "interface"
  "let"
  "namespace"
  "new"
  "return"
  "switch"
  "target"
  "throw"
  "try"
  "type"
  "var"
  "void"
  "while"
  "with"
  "yield"
] @keyword

[
  "abstract"
  "as"
  "async"
  "declare"
  "export"
  "extends"
  "from"
  "get"
  "implements"
  "in"
  "instanceof"
  "keyof"
  "of"
  "override"
  "private"
  "protected"
  "public"
  "readonly"
  "set"
  "static"
  "typeof"
] @keyword.modifier


; Types

(type_identifier) @identifier.type
(predefined_type) @identifier.type.builtin

(interface_declaration name: (type_identifier) @identifier.type.declare)
(class_declaration name: (type_identifier) @identifier.type.declare)
(enum_declaration name: (identifier) @identifier.type.declare)
(type_alias_declaration name: (type_identifier) @identifier.type.declare)

; ((identifier) @identifier.type
;  (#match? @identifier.type "^[A-Z]"))

(type_parameters
  "<" @bracket
  ">" @bracket)
(type_arguments
  "<" @bracket
  ">" @bracket)

; Variables

(required_parameter (identifier) @identifier.argument)
(optional_parameter (identifier) @identifier.argument)
(required_parameter
  pattern: (rest_pattern
    "..." @operator
    (identifier) @identifier.argument))
